#include <iostream>
#include <bits/stdc++.h>
using namespace std;
vector<int> getcycle(vector<int> &from , int last) {
vector<int> cycle;
for(int v = from[last] ; v != last ; v = from[v]){
    cycle.push_back(v);
}
cycle.push_back(last);
reverse(cycle.begin() , cycle.end());
return cycle;
}

void DFS(vector<vector<int>> &g , int y , vector<int> &used , vector<int> &from , vector<int> &cycle){
used[y] = 1;
for(int to : g[y]){
 if(to == from[y]){
 continue;
}
else if(used[to] == 0){
 from[to] = y;
 DFS(g , to , used , from , cycle);
}
else if(used[to] ==1){
 from[to] = y;
 cycle = getcycle(from , to);
}
}
 used[y] = 2;
}
struct Point{
    int a;
    int b;
};
bool cmp(int a , int b){
        return a < b;
}
int cnt;
void BFS(long long v , vector<vector<long long>> &g , long long f ,  long long n , vector<int> &l){
    vector d(n  , 1e15);
    d[v] = 0;
    queue<long long> q;
    q.push(v);
    while(!q.empty()){
        long long u = q.front();
        q.pop();
        for(long long to : g[u]){
            if(d[to] > d[u]+1){
                d[to] = d[u]+1;
                q.push(to);
            }
        }
    }
    for(int i =0; i < n ; i++){
            if(d[i] <= f && d[i]!= 1e15){
                if(l[i] == -1){
                    cnt++;
                }
                l[i] = 1;
            }
    }
}
int main() {
    long long  n ,m , k;
    cin >> n >> m >> k;
    vector<vector<long long>> g(n);
    vector<vector<long long>> e(n);
    vector<int> l(n , -1);
    for(int i = 0; i < m ; i ++){
        long long y , z;
        cin >> y >> z;
        g[y-1].push_back(z-1);
        g[z-1].push_back(y-1);
    }
    vector<pair<long long ,long long>> f(k);
    for(int i = 0; i < k ; i++){
        cin >> f[i].first >> f[i].second;
        f[i].first--;
    }
    for(auto &y : f){
        BFS(y.first , g , y.second , n , l);
    }
        cout << cnt << endl;
        for(int i =0; i < n; i++){
            if(l[i]== 1){
                cout << i +1 << " ";
            }
        }
    return 0;
}

